# parent.py - defines Parent class used by all children classes in cistematic.programs
#
class Parent:
    contents = ''
    tagID = ''
    
    # constructor - inputFilePath is supposed to be data and outputFilePath the results
    #               although usage can be redefined by children
    def __init__(self, tagID='', inputFilePath='', outputFilePath=''):
        self.tagID = ''
        self.inputFilePath = inputFilePath
        self.outputFilePath = outputFilePath

    def setTagID(self, tid):
        self.tagID = tid
    
    def name(self):
        return self.__class__.__name__
    
    # inputFile() - set the inputFile
    def inputFile(self, inputFilePath):
        self.inputFilePath = inputFilePath
    
    # outputFile() - set the outputFile
    def outputFile(self, outputFilePath):
        self.outputFilePath = outputFilePath

    # setSeqLength() - only implemented by those programs who need it
    def setSeqLength(self, length):
        pass
    
    # run() - method will be implemented by children
    def run(self):
        pass
    
    # display() - show all of the lines in contents
    def display(self):
        for line in self.contents:
            print line
    
    # load() - load previously saved data for further processing
    def load(self, inFilePath):
        inFile = open(inFilePath, 'r')
        
        self.contents = inFile.readlines()
        
        inFile.close()
    
    # save() - save all of contents to outputFilePath
    def save(self):
        outFile = open(self.outputFilePath, 'w')
        
        for line in self.contents:
            outFile.write(line)
        
        outFile.close()