###########################################################################
#                                                                         #
# C O P Y R I G H T   N O T I C E                                         #
#  Copyright (c) 2003-5 by:                                               #
#    * California Institute of Technology                                 #
#                                                                         #
#    All Rights Reserved.                                                 #
#                                                                         #
# Permission is hereby granted, free of charge, to any person             #
# obtaining a copy of this software and associated documentation files    #
# (the "Software"), to deal in the Software without restriction,          #
# including without limitation the rights to use, copy, modify, merge,    #
# publish, distribute, sublicense, and/or sell copies of the Software,    #
# and to permit persons to whom the Software is furnished to do so,       #
# subject to the following conditions:                                    #
#                                                                         #
# The above copyright notice and this permission notice shall be          #
# included in all copies or substantial portions of the Software.         #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND                   #
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS     #
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN      #
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN       #
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE        #
# SOFTWARE.                                                               #
###########################################################################
#
# data for Saccharomyces Kluyveri
from os import environ

if environ.get("CISTEMATIC_ROOT"):
    cisRoot = environ.get("CISTEMATIC_ROOT") 
else:
    cisRoot = '/proj/genome'

geneIndex = cisRoot + '/S_kluyveri/WashU/orf_dna/skluyveri.inf' 
chromRoot= cisRoot + '/S_kluyveri/WashU/orf_dna/'

chromDict = { '1': 'orf_genomic_1000'}

annotFile=''
goFile=''

# geneInfo() - is really just a stub in this case
def geneInfo(entry):
    return (entry[0], entry[1], entry[2], entry[3], entry[4], entry[5])

# parseEntry() - must deal with which data to bring in - currently only looking 
#                for genes with basepair coordinates
def parseEntry(entry):
    cols = entry.split()
    name = cols[0]
    
    (chromosome, beg, end, orientation) = ('1', cols[1], cols[2], 'F')
        
    start = int(beg)
    stop  = int(end)
    length = abs (start - stop)
    
    return (name.upper(), (name, chromosome, start, stop, length, orientation))

def annotInfo(orf):
    #inFile2 = open(annotFile, 'r')
    #entries2 = inFile2.readlines()
    
    annotations = []
    
    #for entry in entries2:
    #    try:
    #        fields = entry.split('\t')
    #        if fields[0].strip() == orf:
    #            annotations.append(fields[3])
    #    except:
    #        pass
    
    return annotations

def allAnnotInfo(orf):
    #inFile2 = open(annotFile, 'r')
    #entries2 = inFile2.readlines()
    
    annotations = {}    
    return annotations

def allGOInfo():
    #inFile1 = open(goFile,'r')
    #entries = inFile1.readlines()
    
    annotations = {}
    return annotations

def goInfo(orf):
    #inFile1 = open(goFile,'r')
    #entries = inFile1.readlines()
    
    annotations = []

    #for entry in entries:
    #    try:
    #        fields = entry.split('\t')
    #        if fields[1].strip() == orf:
    #            annot = '%s\t%s\t%s' % (fields[4], fields[5], fields[8])
    #            annotations.append(annot)
    #    except:
    #        pass
    
    return annotations
